/* -*- c++ -*- */
#ifndef AKAXISO2_XML_DESERIALIZER_ANY_ARRAY_HANDLER_H__
#define AKAXISO2_XML_DESERIALIZER_ANY_ARRAY_HANDLER_H__

/** @file akaxiso2/deserializer/any_array_handler.h */

#include <akaxiso2/XML/deserializer/handler.h>

namespace aka2 {

  class any_array_handler : public handler {
  public:
    any_array_handler(bool emptiable, any_array &an, int depth, 
		      const element_props &props,
		      parser_context &context);

    virtual ~any_array_handler();
    virtual validation_result query_element(const qname &tagname, const attribute_values &attrs);
    virtual validation_result end_element(const qname &tagname);
    virtual validation_result query_next(const qname &tagname, const attribute_values &attrs);
    virtual bool parse_entity(const std::string &entity);

    virtual node get_node();
    virtual void receive_child(const node &child);
    virtual bool can_skip();
    virtual void abort();
    
  private:
    any_array &anys_;
    const occurrence &occ_;
    const element_props &props_;
    any *any_;
  };

} // namespace aka2

#endif
