/* -*- c++ -*- */
#ifndef AKAXISO2_XML_DESERIALIZER_CLOSURE_HANDLER_H__
#define AKAXISO2_XML_DESERIALIZER_CLOSUER_HANDLER_H__

#include <akaxiso2/XML/deserializer/handler.h>
#include <akaxiso2/XML/deserializer/sequence_handler.h>

namespace aka2 {

  class closure_handler : public handler {
  public:
    closure_handler(int depth, sequence_handler *seq, 
		    const qname &tagname, const element_props &props);
    virtual ~closure_handler(){}
    virtual validation_result query_element(const qname &tagname, const attribute_values &attrs);
    virtual validation_result end_element(const qname &tagname);
    virtual validation_result query_next(const qname &tagname, const attribute_values &attrs);
    virtual bool parse_entity(const std::string &entity);

    virtual node get_node();
    virtual void receive_child(const node &child);
    virtual bool can_skip();
    virtual void abort(){}

  private:
    sequence_handler *seqhandler_;
    sequence_handler *inner_;
    qname tagname_;
  };

}

#endif
