/** -*- c++ -*- */
#ifndef AKAXISO2_XML_DESERIALIZER_FIXED_HANDLER_H__
#define AKAXISO2_XML_DESERIALIZER_FIXED_HANDLER_H__

/** @file akaxiso2/XML/deserializer/fixed_handler.h */

#include <akaxiso2/XML/deserializer/handler.h>

namespace aka2 {

  class fixed_handler : public handler {
  public:
    fixed_handler(void *elm, const fixed_op &fop,
		  int depth, 
		  const qname& tagname, const element_props &props,
		  parser_context &context);

    virtual ~fixed_handler(){}
    virtual validation_result query_element(const qname &tagname, const attribute_values &attrs);
    virtual validation_result end_element(const qname &tagname);
    virtual validation_result query_next(const qname &tagname, const attribute_values &attrs);
    virtual bool parse_entity(const std::string &entity);

    virtual node get_node();
    virtual void receive_child(const node &child);
    virtual bool can_skip();
    virtual void abort();
  private:
    void *e_;
    const fixed_op &fop_;
    qname tagname_;
  };

} // namespace aka2

#endif
