/* -*- c++ -*- */
#ifndef AKAXISO2_XML_DESERIALIZER_SIMPLETYPE_HANDLER_H__
#define AKAXISO2_XML_DESERIALIZER_SIMPLETYPE_HANDLER_H__

#include <akaxiso2/XML/deserializer/handler.h>

namespace aka2 {

  class simpletype_handler : public handler {
  public:
    simpletype_handler(void *sim, const simpletype_op &sop,
		       int depth, 
		       const element_props &props, 
		       parser_context &context);
    virtual ~simpletype_handler(){}
    virtual validation_result query_element(const qname &tagname, const attribute_values &attrs);
    virtual validation_result end_element(const qname &tagname);
    virtual validation_result query_next(const qname &tagname, const attribute_values &attrs);

    virtual bool parse_entity(const std::string &entity);

    // Mainly used for choices.
    virtual node get_node();
    virtual void receive_child(const node &child);

    virtual bool can_skip();
    virtual void abort(); 

  private:
    void *elm_;
    const simpletype_op &sop_;
  };

}

#endif

