/* -*- c++ -*- */
#ifndef XMLSchema_xiso_h__
#define XMLSchema_xiso_h__

#include <osixaka2/XMLSchema.h>

#include <osixaka2/xml_xiso.h>

#include <osixaka2/osx_xiso.h>

#include <akaxiso2/content_model.h>
#include <osixaka2/schema_st_xiso.h>


namespace xs {

  typedef xs::allNNI_leaf all_maxOccurs_leaf;
  typedef aka::sequential_array< ::xs::all_maxOccurs_array, xs::allNNI_leaf > all_maxOccurs_array_leaf;

  typedef xiso::leaf< ::xs::nonNegativeInteger> all_minOccurs_leaf;
  typedef aka::sequential_array< ::xs::all_minOccurs_array, xiso::leaf< ::xs::all_minOccurs> > all_minOccurs_array_leaf;

  typedef xiso::leaf< ::xs::NMTOKEN> attribute_use_leaf;
  typedef aka::sequential_array< ::xs::attribute_use_array, xiso::leaf< ::xs::attribute_use> > attribute_use_array_leaf;

  typedef xiso::leaf< ::std::string> blockSet_leaf;
  typedef aka::sequential_array< ::xs::blockSet_array, xiso::leaf< ::std::string> > blockSet_array_leaf;

  typedef xiso::leaf< ::xs::NMTOKEN> derivationControl_leaf;
  typedef aka::sequential_array< ::xs::derivationControl_array, xiso::leaf< ::xs::derivationControl> > derivationControl_array_leaf;

  typedef xiso::leaf< ::std::string> derivationSet_leaf;
  typedef aka::sequential_array< ::xs::derivationSet_array, xiso::leaf< ::std::string> > derivationSet_array_leaf;

  typedef xiso::leaf< ::xs::token> field_xpath_leaf;
  typedef aka::sequential_array< ::xs::field_xpath_array, xiso::leaf< ::xs::field_xpath> > field_xpath_array_leaf;

  typedef xiso::leaf< ::xs::NMTOKEN> formChoice_leaf;
  typedef aka::sequential_array< ::xs::formChoice_array, xiso::leaf< ::xs::formChoice> > formChoice_array_leaf;

  typedef xiso::leaf< ::std::string> fullDerivationSet_leaf;
  typedef aka::sequential_array< ::xs::fullDerivationSet_array, xiso::leaf< ::std::string> > fullDerivationSet_array_leaf;

  typedef xiso::leaf< ::std::string> namespaceList_leaf;
  typedef aka::sequential_array< ::xs::namespaceList_array, xiso::leaf< ::std::string> > namespaceList_array_leaf;

  typedef xs::allNNI_leaf narrowMaxMin_maxOccurs_leaf;
  typedef aka::sequential_array< ::xs::narrowMaxMin_maxOccurs_array, xs::allNNI_leaf > narrowMaxMin_maxOccurs_array_leaf;

  typedef xiso::leaf< ::xs::nonNegativeInteger> narrowMaxMin_minOccurs_leaf;
  typedef aka::sequential_array< ::xs::narrowMaxMin_minOccurs_array, xiso::leaf< ::xs::narrowMaxMin_minOccurs> > narrowMaxMin_minOccurs_array_leaf;

  typedef xiso::leaf< ::xs::token> public_leaf;
  typedef aka::sequential_array< ::xs::public_array, xiso::leaf< ::xs::_public> > public_array_leaf;

  typedef xiso::leaf< ::xs::derivationControl> reducedDerivationControl_leaf;
  typedef aka::sequential_array< ::xs::reducedDerivationControl_array, xiso::leaf< ::xs::reducedDerivationControl> > reducedDerivationControl_array_leaf;

  typedef xiso::leaf< ::xs::token> selector_xpath_leaf;
  typedef aka::sequential_array< ::xs::selector_xpath_array, xiso::leaf< ::xs::selector_xpath> > selector_xpath_array_leaf;

  typedef xiso::leaf< ::std::string> simpleDerivationSet_leaf;
  typedef aka::sequential_array< ::xs::simpleDerivationSet_array, xiso::leaf< ::std::string> > simpleDerivationSet_array_leaf;

  typedef xiso::leaf< ::xs::derivationControl> typeDerivationControl_leaf;
  typedef aka::sequential_array< ::xs::typeDerivationControl_array, xiso::leaf< ::xs::typeDerivationControl> > typeDerivationControl_array_leaf;

  typedef xiso::leaf< ::std::string> union_memberTypes_leaf;
  typedef aka::sequential_array< ::xs::union_memberTypes_array, xiso::leaf< ::std::string> > union_memberTypes_array_leaf;

  typedef xiso::leaf< ::xs::NMTOKEN> whiteSpace_value_leaf;
  typedef aka::sequential_array< ::xs::whiteSpace_value_array, xiso::leaf< ::xs::whiteSpace_value> > whiteSpace_value_array_leaf;

  typedef xiso::leaf< ::xs::NMTOKEN> wildcard_processContents_leaf;
  typedef aka::sequential_array< ::xs::wildcard_processContents_array, xiso::leaf< ::xs::wildcard_processContents> > wildcard_processContents_array_leaf;

  struct appinfo_leaf : aka::sequence< ::xs::appinfo, appinfo_leaf> {
    void model();
  };

  struct documentation_leaf : aka::sequence< ::xs::documentation, documentation_leaf> {
    void model();
  };

  struct annotation_choice_leaf : aka::sequential_choice< ::xs::annotation_choice, annotation_choice_leaf> {
    void model();
  };

  struct annotation_leaf : aka::sequence< ::xs::annotation, annotation_leaf> {
    void model();
  };

  struct annotated_leaf : aka::sequence< ::xs::annotated, annotated_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::annotated_array, ::xs::annotated_leaf > annotated_array_leaf;

  struct anyType_leaf : aka::sequence< ::xs::anyType, anyType_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::anyType_array, ::xs::anyType_leaf > anyType_array_leaf;

  struct attributeGroupRef_leaf : aka::sequence< ::xs::attributeGroupRef, attributeGroupRef_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::attributeGroupRef_array, ::xs::attributeGroupRef_leaf > attributeGroupRef_array_leaf;

  struct groupRef_leaf : aka::sequence< ::xs::groupRef, groupRef_leaf> {
    void model();
  };

  struct facet_leaf : aka::sequence< ::xs::facet, facet_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::facet_array, ::xs::facet_leaf > facet_array_leaf;

  typedef aka::sequential_array< ::xs::groupRef_array, ::xs::groupRef_leaf > groupRef_array_leaf;

  struct selector_leaf : aka::sequence< ::xs::selector, selector_leaf> {
    void model();
  };

  struct field_leaf : aka::sequence< ::xs::field, field_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::field_array, ::xs::field_leaf > field_array_leaf;

  struct keybase_leaf : aka::sequence< ::xs::keybase, keybase_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::keybase_array, ::xs::keybase_leaf > keybase_array_leaf;

  struct noFixedFacet_leaf : aka::sequence< ::xs::noFixedFacet, noFixedFacet_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::noFixedFacet_array, ::xs::noFixedFacet_leaf > noFixedFacet_array_leaf;

  struct numFacet_leaf : aka::sequence< ::xs::numFacet, numFacet_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::numFacet_array, ::xs::numFacet_leaf > numFacet_array_leaf;

  struct openAttrs_leaf : aka::sequence< ::xs::openAttrs, openAttrs_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::openAttrs_array, ::xs::openAttrs_leaf > openAttrs_array_leaf;

  struct wildcard_leaf : aka::sequence< ::xs::wildcard, wildcard_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::wildcard_array, ::xs::wildcard_leaf > wildcard_array_leaf;

  struct totalDigits_leaf : aka::sequence< ::xs::totalDigits, totalDigits_leaf> {
    void model();
  };

  struct whiteSpace_leaf : aka::sequence< ::xs::whiteSpace, whiteSpace_leaf> {
    void model();
  };

  struct pattern_leaf : aka::sequence< ::xs::pattern, pattern_leaf> {
    void model();
  };

  struct facets_leaf : aka::sequential_choice< ::xs::facets, facets_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::facets_array, ::xs::facets_leaf > facets_array_leaf;

  struct keyref_leaf : aka::sequence< ::xs::keyref, keyref_leaf> {
    void model();
  };

  struct identityConstraint_leaf : aka::sequential_choice< ::xs::identityConstraint, identityConstraint_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::identityConstraint_array, ::xs::identityConstraint_leaf > identityConstraint_array_leaf;

  struct any_leaf : aka::sequence< ::xs::any, any_leaf> {
    void model();
  };

  struct import_leaf : aka::sequence< ::xs::import, import_leaf> {
    void model();
  };

  struct include_leaf : aka::sequence< ::xs::include, include_leaf> {
    void model();
  };

  struct notation_leaf : aka::sequence< ::xs::notation, notation_leaf> {
    void model();
  };

  struct directives_leaf : aka::sequential_choice< ::xs::directives, directives_leaf> {
    void model();
  };

  struct schemaTop_leaf : aka::sequential_choice< ::xs::schemaTop, schemaTop_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::annotation_array, ::xs::annotation_leaf > annotation_array_leaf;

  struct schemaTops_item_leaf : aka::sequence< ::xs::schemaTops_item, schemaTops_item_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::schemaTops, ::xs::schemaTops_item_leaf > schemaTops_leaf;

  typedef aka::sequential_array< ::xs::schemaTop_array, ::xs::schemaTop_leaf > schemaTop_array_leaf;

  struct schema_leaf : aka::sequence< ::xs::schema, schema_leaf> {
    void model();
  };

  struct redefine_choice_leaf : aka::sequential_choice< ::xs::redefine_choice, redefine_choice_leaf> {
    void model();
  };

  struct redefine_leaf : aka::sequence< ::xs::redefine, redefine_leaf> {
    void model();
  };

  struct complexContent_choice_leaf : aka::sequential_choice< ::xs::complexContent_choice, complexContent_choice_leaf> {
    void model();
  };

  struct complexContent_leaf : aka::sequence< ::xs::complexContent, complexContent_leaf> {
    void model();
  };

  struct topLevelElement_sequence_c0_leaf : aka::sequential_choice< ::xs::topLevelElement_sequence_c0, topLevelElement_sequence_c0_leaf> {
    void model();
  };

  struct topLevelElement_leaf : aka::sequence< ::xs::topLevelElement, topLevelElement_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::topLevelElement_array, ::xs::topLevelElement_leaf > topLevelElement_array_leaf;

  struct restrictionType_sequence_c0_leaf : aka::sequential_choice< ::xs::restrictionType_sequence_c0, restrictionType_sequence_c0_leaf> {
    void model();
  };

  struct realGroup_sequence_c0_leaf : aka::sequential_choice< ::xs::realGroup_sequence_c0, realGroup_sequence_c0_leaf> {
    void model();
  };

  struct realGroup_leaf : aka::sequence< ::xs::realGroup, realGroup_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::realGroup_array, ::xs::realGroup_leaf > realGroup_array_leaf;

  struct namedGroup_sequence_c0_leaf : aka::sequential_choice< ::xs::namedGroup_sequence_c0, namedGroup_sequence_c0_leaf> {
    void model();
  };

  struct namedGroup_leaf : aka::sequence< ::xs::namedGroup, namedGroup_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::namedGroup_array, ::xs::namedGroup_leaf > namedGroup_array_leaf;

  struct localElement_sequence_c0_leaf : aka::sequential_choice< ::xs::localElement_sequence_c0, localElement_sequence_c0_leaf> {
    void model();
  };

  struct localElement_leaf : aka::sequence< ::xs::localElement, localElement_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::localElement_array, ::xs::localElement_leaf > localElement_array_leaf;

  struct element_sequence_c0_leaf : aka::sequential_choice< ::xs::element_sequence_c0, element_sequence_c0_leaf> {
    void model();
  };

  struct element_leaf : aka::sequence< ::xs::element, element_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::element_array, ::xs::element_leaf > element_array_leaf;

  struct simpleContent_choice_leaf : aka::sequential_choice< ::xs::simpleContent_choice, simpleContent_choice_leaf> {
    void model();
  };

  struct simpleContent_leaf : aka::sequence< ::xs::simpleContent, simpleContent_leaf> {
    void model();
  };

  struct typeDefParticle_leaf : aka::sequential_choice< ::xs::typeDefParticle, typeDefParticle_leaf> {
    void model();
  };

  struct attrDecls_c0_leaf : aka::sequential_choice< ::xs::attrDecls_c0, attrDecls_c0_leaf> {
    void model();
  };

  struct attrDecls_leaf : aka::sequence< ::xs::attrDecls, attrDecls_leaf> {
    void model();
  };

  struct complexTypeModelParticle_leaf : aka::sequence< ::xs::complexTypeModelParticle, complexTypeModelParticle_leaf> {
    void model();
  };

  struct attributeGroup_leaf : aka::sequence< ::xs::attributeGroup, attributeGroup_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::attributeGroup_array, ::xs::attributeGroup_leaf > attributeGroup_array_leaf;

  struct complexRestrictionType_leaf : aka::sequence< ::xs::complexRestrictionType, complexRestrictionType_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::complexRestrictionType_array, ::xs::complexRestrictionType_leaf > complexRestrictionType_array_leaf;

  struct complexTypeModel_leaf : aka::sequential_choice< ::xs::complexTypeModel, complexTypeModel_leaf> {
    void model();
  };

  struct complexType_leaf : aka::sequence< ::xs::complexType, complexType_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::complexType_array, ::xs::complexType_leaf > complexType_array_leaf;

  struct extensionType_leaf : aka::sequence< ::xs::extensionType, extensionType_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::extensionType_array, ::xs::extensionType_leaf > extensionType_array_leaf;

  struct localComplexType_leaf : aka::sequence< ::xs::localComplexType, localComplexType_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::localComplexType_array, ::xs::localComplexType_leaf > localComplexType_array_leaf;

  struct namedAttributeGroup_leaf : aka::sequence< ::xs::namedAttributeGroup, namedAttributeGroup_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::namedAttributeGroup_array, ::xs::namedAttributeGroup_leaf > namedAttributeGroup_array_leaf;

  struct restrictionType_leaf : aka::sequence< ::xs::restrictionType, restrictionType_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::restrictionType_array, ::xs::restrictionType_leaf > restrictionType_array_leaf;

  struct simpleExtensionType_leaf : aka::sequence< ::xs::simpleExtensionType, simpleExtensionType_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::simpleExtensionType_array, ::xs::simpleExtensionType_leaf > simpleExtensionType_array_leaf;

  struct topLevelComplexType_leaf : aka::sequence< ::xs::topLevelComplexType, topLevelComplexType_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::topLevelComplexType_array, ::xs::topLevelComplexType_leaf > topLevelComplexType_array_leaf;

  typedef aka::sequential_array< ::xs::attrDecls_array, ::xs::attrDecls_leaf > attrDecls_array_leaf;

  typedef aka::sequential_array< ::xs::complexTypeModel_array, ::xs::complexTypeModel_leaf > complexTypeModel_array_leaf;

  typedef aka::sequential_array< ::xs::typeDefParticle_array, ::xs::typeDefParticle_leaf > typeDefParticle_array_leaf;

  struct narrowMaxMin_sequence_c0_leaf : aka::sequential_choice< ::xs::narrowMaxMin_sequence_c0, narrowMaxMin_sequence_c0_leaf> {
    void model();
  };

  struct narrowMaxMin_leaf : aka::sequence< ::xs::narrowMaxMin, narrowMaxMin_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::narrowMaxMin_array, ::xs::narrowMaxMin_leaf > narrowMaxMin_array_leaf;

  struct allModel_leaf : aka::sequence< ::xs::allModel, allModel_leaf> {
    void model();
  };

  struct namedGroup_sequence_c0_all_leaf : aka::sequence< ::xs::namedGroup_sequence_c0_all, namedGroup_sequence_c0_all_leaf> {
    void model();
  };

  struct all_leaf : aka::sequence< ::xs::all, all_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::all_array, ::xs::all_leaf > all_array_leaf;

  typedef aka::sequential_array< ::xs::allModel_array, ::xs::allModel_leaf > allModel_array_leaf;

  struct attribute_leaf : aka::sequence< ::xs::attribute, attribute_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::attribute_array, ::xs::attribute_leaf > attribute_array_leaf;

  struct nestedParticle_leaf : aka::sequential_choice< ::xs::nestedParticle, nestedParticle_leaf> {
    void model();
  };

  struct explicitGroup_leaf : aka::sequence< ::xs::explicitGroup, explicitGroup_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::explicitGroup_array, ::xs::explicitGroup_leaf > explicitGroup_array_leaf;

  struct particle_leaf : aka::sequential_choice< ::xs::particle, particle_leaf> {
    void model();
  };

  struct group_leaf : aka::sequence< ::xs::group, group_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::group_array, ::xs::group_leaf > group_array_leaf;

  struct simpleExplicitGroup_leaf : aka::sequence< ::xs::simpleExplicitGroup, simpleExplicitGroup_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::simpleExplicitGroup_array, ::xs::simpleExplicitGroup_leaf > simpleExplicitGroup_array_leaf;

  typedef aka::sequential_array< ::xs::nestedParticle_array, ::xs::nestedParticle_leaf > nestedParticle_array_leaf;

  typedef aka::sequential_array< ::xs::particle_array, ::xs::particle_leaf > particle_array_leaf;

  struct simpleDerivation_leaf : aka::sequential_choice< ::xs::simpleDerivation, simpleDerivation_leaf> {
    void model();
  };

  struct localSimpleType_leaf : aka::sequence< ::xs::localSimpleType, localSimpleType_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::localSimpleType_array, ::xs::localSimpleType_leaf > localSimpleType_array_leaf;

  struct simpleRestrictionModel_leaf : aka::sequence< ::xs::simpleRestrictionModel, simpleRestrictionModel_leaf> {
    void model();
  };

  struct simpleRestrictionType_leaf : aka::sequence< ::xs::simpleRestrictionType, simpleRestrictionType_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::simpleRestrictionType_array, ::xs::simpleRestrictionType_leaf > simpleRestrictionType_array_leaf;

  struct simpleType_leaf : aka::sequence< ::xs::simpleType, simpleType_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::simpleType_array, ::xs::simpleType_leaf > simpleType_array_leaf;

  struct topLevelAttribute_leaf : aka::sequence< ::xs::topLevelAttribute, topLevelAttribute_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::topLevelAttribute_array, ::xs::topLevelAttribute_leaf > topLevelAttribute_array_leaf;

  struct topLevelSimpleType_leaf : aka::sequence< ::xs::topLevelSimpleType, topLevelSimpleType_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::topLevelSimpleType_array, ::xs::topLevelSimpleType_leaf > topLevelSimpleType_array_leaf;

  struct redefinable_leaf : aka::sequential_choice< ::xs::redefinable, redefinable_leaf> {
    void model();
  };

  typedef aka::sequential_array< ::xs::redefinable_array, ::xs::redefinable_leaf > redefinable_array_leaf;

  typedef aka::sequential_array< ::xs::simpleDerivation_array, ::xs::simpleDerivation_leaf > simpleDerivation_array_leaf;

  typedef aka::sequential_array< ::xs::simpleRestrictionModel_array, ::xs::simpleRestrictionModel_leaf > simpleRestrictionModel_array_leaf;

  struct list_leaf : aka::sequence< ::xs::list, list_leaf> {
    void model();
  };

  struct restriction_leaf : aka::sequence< ::xs::restriction, restriction_leaf> {
    void model();
  };

  struct union_leaf : aka::sequence< ::xs::_union, union_leaf> {
    void model();
  };


}

#endif // #ifndef XMLSchema_xiso_h__
